#include "vector.h"

// 初始化Vector
void vector_init(Vector *vector)
{
    vector->size = 0;
    vector->capacity = 4; // 初始容量
    vector->data = (int *)malloc(sizeof(int) * vector->capacity);
}

// 释放Vector占用的内存
void vector_free(Vector *vector)
{
    free(vector->data);
    vector->data = NULL;
    vector->size = 0;
    vector->capacity = 0;
}

// 扩展Vector的容量
void vector_expand(Vector *vector)
{
    vector->capacity *= 2;
    vector->data = (int *)realloc(vector->data, sizeof(int) * vector->capacity);
}

// 向Vector末尾添加元素
void vector_push_back(Vector *vector, int value)
{
    if (vector->size == vector->capacity)
        vector_expand(vector);
    vector->data[vector->size++] = value;
}

// 获取Vector中的元素
int vector_get(Vector *vector, size_t index)
{
    if (index < vector->size)
        return vector->data[index];
    return -1; // 返回-1表示索引无效
}

// 删除Vector中的元素
int vector_pop_back(Vector *vector)
{
    if (vector->size <= 0)
        return -1;
    return vector->data[--vector->size];
}

// 获取Vector的大小
int vector_size(Vector *vector)
{
    return vector->size;
}

// 判断Vetcor是否为空
bool vector_empty(Vector *vector)
{
    return vector->size == 0;
}