#include <stdlib.h>
#include <stdbool.h>

typedef struct Vector
{
    int *data;    // 动态数组
    int size;     // 当前元素个数
    int capacity; // 数组的容量

    // 函数指针
    void (*ctor)(struct Vector *);
    void (*dtor)(struct Vector *);
    void (*push)(struct Vector *, int);
    int (*at)(struct Vector *, size_t);
    int (*pop)(struct Vector *);
    int (*getsize)(struct Vector *);
    bool (*empty)(struct Vector *);
} Vector;

// 初始化Vector
void vector_init(Vector *vector);

// 释放Vector占用的内存
void vector_free(Vector *vector);

// 扩展Vector的容量
void vector_expand(Vector *vector);

// 向Vector末尾添加元素
void vector_push_back(Vector *vector, int value);

// 获取Vector中的元素
int vector_get(Vector *vector, size_t index);

// 删除Vector中的元素
int vector_pop_back(Vector *vector);

// 获取Vector的大小
int vector_size(Vector *vector);

// 判断Vetcor是否为空
bool vector_empty(Vector *vector);